package com.matejdro.bukkit.jail;

import org.bukkit.Material;
import org.bukkit.block.Sign;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.material.MaterialData;


public class JailPrisoner {
	private String name;
	private int remaintime;
	private JailZone jail;
	private Boolean offline;
	private String transferDest = "";
	private Boolean releasing = false;
	private Boolean muted = false;
	private String reason = "";
	private JailCell cell;
	private String inventory = "";
	private String jailer = "";
	
	public JailPrisoner()
	{
		offline = false;
		transferDest = "";
		releasing = false;
	}
	
	public JailPrisoner(String Name, int Remaintime, String Jail, Boolean Offline, String TransferDest, String Reason, Boolean Muted, String Inventory, String Jailer)
	{
		name = Name.toLowerCase();
		remaintime = Remaintime;
		setJail(Jail);
		offline = Offline;
		transferDest = TransferDest;
		muted = Muted;
		reason = Reason;
		inventory = Inventory;
		jailer = Jailer;
	}
		
	public String getName()
	{
		return name;
	}
		
	public int getRemainingTime()
	{
		return remaintime;
	}
	
	public void setRemainingTime(int input)
	{
		remaintime = input;
		DrawSign();
	}
	
	public JailZone getJail()
	{
		return jail;
	}
		
	public void setJail(JailZone input)
	{
		jail = input;
	}
	
	public void setJail(String jailname)
	{
		jail = Jail.zones.get(jailname);
	}
	
	public Boolean OfflinePending()
	{
		return offline;
	}
	
	public void setOfflinePending(Boolean input)
	{
		offline = input;
	}
	
	public String getTransferDestination()
	{
		return transferDest;
	}
	
	public void setTransferDestination(String input)
	{
		transferDest = input;
	}
	
	public Boolean isBeingReleased()
	{
		return releasing;
	}
	
	public void SetBeingReleased(Boolean input)
	{
		releasing = input;
	}
	
	public String getReason()
	{
		return reason;
	}
	
	public void setReason(String input)
	{
		reason = input;
	}
	
	public Boolean isMuted()
	{
		return muted;
	}
	
	public void setMuted(Boolean input)
	{
		muted = input;
	}
	
	public JailCell getCell()
	{
		return cell;
	}
	
	public String getInventory()
	{
		return inventory;
	}

	public void setCell(JailCell input)
	{
		cell = input;
	}
	
	public String getJailer()
	{
		return jailer;
	}

	
	public void StoreInventory(Inventory playerinv)
	{
		String inv = "";
		
		for (int i = 0;i<playerinv.getSize();i++)
		{
			ItemStack item = playerinv.getItem(i);
			if (item == null || item.getType() == Material.AIR) continue;
			byte data = (byte) 0;
			if (item.getData() != null) data = item.getData().getData();
			inv += String.valueOf(item.getTypeId()) + "," + String.valueOf(item.getAmount()) + "," +String.valueOf(item.getDurability()) + "," +String.valueOf(data) + ";";
			playerinv.clear(i);
		}
		inventory = inv;
		InputOutput.UpdatePrisoner(this);
	}
	
	public void RestoreInventory(Inventory playerinv)
	{
		if (inventory == null) return;
		String[] inv = inventory.split(";");
		for (String i : inv)
		{
			if (i == null || i.trim().equals("")) return;
			String[] items = i.split(",");
			ItemStack item = new ItemStack(Integer.parseInt(items[0]),Integer.parseInt(items[1]));
			item.setDurability(Short.parseShort(items[2]));
			item.setData(new MaterialData(Byte.parseByte(items[3])));
			playerinv.addItem(item);
		}
		inventory = "";
		InputOutput.UpdatePrisoner(this);
	}
	
	public void DrawSign()
	{
		if (cell != null && cell.getSign() != null) 
		{
			Sign sign = cell.getSign();
			String[] lines = Settings.SignText.split("\\[NEWLINE\\]");
			int max = lines.length;
			if (max > 4) max = 4;
			for (int i = 0;i<max;i++)
			{
				String str = lines[i];
				str = str.replace("<Player>", getName());
				str = str.replace("<Time>", String.valueOf(getRemainingTime() / 6));
				str = str.replace("<Reason>", getReason());
				sign.setLine(i, str);
			}
			sign.update();
		}

	}
}
