package com.matejdro.bukkit.jail;

import java.util.HashSet;

import org.bukkit.Location;

public class JailZone {
	String name;
	double X1;
	double Y1;
	double Z1;
	double X2;
	double Y2;
	double Z2;
	double teleX;
	double teleY;
	double teleZ;
	double freeX;
	double freeY;
	double freeZ;
	String teleWorldname;
	String freeWorldname;
	HashSet<JailCell> cells = new HashSet<JailCell>();
	
	public String getBackupString()
	{
		String bs = "";
		
		bs+= "name=" + name + ";";
		bs+= "X1=" + String.valueOf(X1) + ";";
		bs+= "Y1=" + String.valueOf(Y1) + ";";
		bs+= "Z1=" + String.valueOf(Z1) + ";";
		bs+= "X2=" + String.valueOf(X2) + ";";
		bs+= "Y2=" + String.valueOf(Y2) + ";";
		bs+= "Z2=" + String.valueOf(Z2) + ";";
		bs+= "teleX=" + String.valueOf(teleX) + ";";
		bs+= "teleY=" + String.valueOf(teleY) + ";";
		bs+= "teleZ=" + String.valueOf(teleZ) + ";";
		bs+= "freeX=" + String.valueOf(freeX) + ";";
		bs+= "freeY=" + String.valueOf(freeY) + ";";
		bs+= "freeZ=" + String.valueOf(freeZ) + ";";
		bs+= "teleWorld=" + String.valueOf(teleWorldname) + ";";
		bs+= "freeWorld=" + String.valueOf(freeWorldname) + "";
		
		return bs;
		
	}
	
	public JailZone(String pname, double pX1, double pY1, double pZ1, double pX2, double pY2, double pZ2, double pteleX, double pteleY, double pteleZ, double pfreeX, double pfreeY, double pfreeZ, String pteleWorld, String pfreeWorld)
	{
		name = pname.toLowerCase();
		X1 = pX1;
		Y1 = pY1;
		Z1 = pZ1;
		X2 = pX2;
		Y2 = pY2;
		Z2 = pZ2;
		teleX = pteleX;
		teleY = pteleY;
		teleZ = pteleZ;
		freeX = pfreeX;
		freeY = pfreeY;
		freeZ = pfreeZ;
		teleWorldname = pteleWorld;
		freeWorldname = pfreeWorld;
	}
	
	public String getName()
	{
		return name;
	}
	
	public Location getTeleportLocation()
	{
		
		return (new Location(Jail.instance.getServer().getWorld(teleWorldname), teleX, teleY, teleZ));
	}
	
	public JailCell getEmptyCell()
	{
		for (JailCell c : cells)
		{
			if (c.getPlayerName() == null || c.getPlayerName().trim().equals(""))
			{
				return c;
			}
		}
		return null;
	}

	
	public Location getReleaseTeleportLocation()
	{
		return (new Location(Jail.instance.getServer().getWorld(freeWorldname), freeX, freeY, freeZ));
	}
	
	public Boolean IsInside(Location loc)
	{
		if (IsBetween(X1,X2, loc.getX()) && IsBetween(Y1,Y2, loc.getY()) && IsBetween(Z1,Z2, loc.getZ()) )
			return true;
		return false;
	}
	
	public double getDistance(Location loc)
	{
		return(Math.abs(loc.getX() - teleX) + Math.abs(loc.getY() - teleY) + Math.abs(loc.getZ() + teleZ));
	}
	
	public HashSet<JailCell> getCellList()
	{
		return cells;
	}
	
	private Boolean IsBetween(double x, double y, double n)
	{
		if ((x < y) && x <= n && y >= n )
			return true;
		else if ((x > y) && x >= n && y <= n )
			return true;
		return false;
		
			
	}
	
	
}
